#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

#define all(c) (c).begin(),(c).end()
#define sz(c) (int)(c).size()
#define pb push_back
#define mp make_pair
#define x first
#define y second
#define image(a) {sort(all(a)), a.resize(unique(all(a)) - a.begin());}
const ld eps = 1e-6;
struct pnt {
  ld x, y;
  pnt() {
  }
  pnt(ld _x, ld _y) : x(_x), y(_y) {
  }
};
pnt operator - (const pnt& a, const pnt& b) {
  return {a.x - b.x, a.y - b.y};
}
pnt operator + (const pnt& a, const pnt& b) {
  return {a.x + b.x, a.y + b.y};
}
pnt operator * (const pnt& a, ld c) {
  return {a.x * c, a.y * c};
}
bool operator < (const pnt& a, const pnt& b) {
  return a.x < b.x - eps || (fabs(a.x - b.x) <= eps && a.y < b.y - eps);
}
ld sp(const pnt& a, const pnt& b) {
  return a.x * b.x + a.y * b.y;
}
ld vp(const pnt& a, const pnt& b) {
  return a.x * b.y - a.y * b.x;
}
struct line {
  ld a, b, c;
  line() {
  };
  line(const pnt& p1, const pnt& p2) {
    a = p1.y - p2.y;
    b = p2.x - p1.x;
    c = -(a * p1.x + b * p1.y);
  }
};
pair<bool, pnt> inters(const line& a, const line& b) {
  ld dd = a.a * b.b - a.b * b.a;
  ld dx = a.c * b.b - a.b * b.c;
  ld dy = a.a * b.c - a.c * b.a;
  if (fabs(dd) <= eps) {
    return mp(false, pnt(0, 0));
  } else {
    return mp(true, pnt(-dx / dd, -dy / dd));
  }
}
bool onside(const pnt& p, const pnt& a, const pnt& b) {
  return fabs(vp(p - a, b - a)) <= eps && sp(p - a, b - a) >= -eps && sp(p - b, a - b) >= -eps;
}
const ld dx[] = {1, 0, -1,  0};
const ld dy[] = {0, 1,  0, -1};
map<pnt, int> was;
map<pnt, set<pnt>> edge;
void dfs(pnt v) {
  if (was[v] == 1) return;
  was[v] = 1;
  for (auto e : edge[v]) {
    dfs(e);
  }
}
int main(){                    
  #ifdef home
  assert(freopen("a.out","wt",stdout));
  assert(freopen("a.in","rt",stdin));
  #endif
  cin.tie(0);
  ios_base::sync_with_stdio(false);           
  pnt p0;
  cin >> p0.x >> p0.y;
  int n;
  cin >> n;
  vector<ld> ls1;
  for (int i = 0; i < n; i++) {
    ld x;
    cin >> x;
    ls1.pb(x);
  }
  pnt p1;
  cin >> p1.x >> p1.y;
  int m;
  cin >> m;
  vector<ld> ls2;
  for (int i = 0; i < m; i++) {
    ld x;
    cin >> x;
    ls2.pb(x);
  }
  ld d = sqrt(sp(p0 - p1, p0 - p1));
  p0 = {0, 0};
  p1 = {d, 0};
  vector<vector<pnt>> poly;
  for (int i = 0; i < n; i++) {
    vector<pnt> cur;
    for (int j = 0; j < 4; j++) {
      cur.pb(p0 + pnt(dx[j], dy[j]) * ls1[i]);
    }
    poly.pb(cur);
  }
  for (int i = 0; i < m; i++) {
    vector<pnt> cur;
    for (int j = 0; j < 4; j++) {
      cur.pb(p1 + pnt(dx[j], dy[j]) * ls2[i]);
    }
    poly.pb(cur);
  }
  for (int i = 0; i < sz(poly); i++) {
    for (int i1 = 0; i1 < sz(poly[i]); i1++) {
      pnt v1 = poly[i][i1];
      pnt v2 = poly[i][(i1 + 1) % sz(poly[i])];
      set<pnt> side;
      side.insert(v1);
      side.insert(v2);
      for (int j = 0; j < sz(poly); j++) if (i != j) {
        for (int j1 = 0; j1 < sz(poly[j]); j1++) {
          pnt u1 = poly[j][j1];
          pnt u2 = poly[j][(j1 + 1) % sz(poly[j])];
          auto p = inters(line(v1, v2), line(u1, u2));
          if (p.x) {
            if (onside(p.y, v1, v2) && onside(p.y, u1, u2)) {
              side.insert(p.y);
            }
          }
        }    
      }
      vector<pnt> sid(side.begin(), side.end());
      for (int j = 0; j + 1 < sz(sid); j++) {
        edge[sid[j]].insert(sid[j + 1]);
        edge[sid[j + 1]].insert(sid[j]);
      }
    }
  }
  int V = sz(edge);
  int E = 0;
  for (auto& x : edge) {
    E += sz(x.y);
  }
  E /= 2;
  int K = 0;
  for (auto& x : edge) {
    if (was[x.x] == 0) {
      dfs(x.x);
      K++;
    }
  }
  int G = 1 + K - (V - E);  
  cout << G - 1 << endl;
  return 0;
}
