#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cstring>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <list>
#include <deque>
#include <queue>
#include <sstream>
#include <iostream>
#include <algorithm>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const double pi = acos(-1.0);
const int size = 2000;
const int w1 = 2;
const int w2 = 1;

const long long inf = 1e18;
const int hmsk = (1 << 16) - 1;
const int ssize = 7;
const int M = 4 * 1000 * 1000;
const int p = 17239;

int col[5 * size][size];
int cols[size * size + 1];
int fatnum[size * size + 1];
int cnt[size * size + 1];
int cnts[size * size + 1];
int n, m, c;
int rem[size][size];
int sum[size * size + 1];
int cur[size * size + 1];
int sethave[size * size + 1];
unsigned int ncol[size][size / 5 + 1];
unsigned int fifth[5 * size][ssize];
char bc[1 << 16];

int hashtable[M];
int hashvalue[M];
int tablesize = 0;

int getnum(int c) {
	int ptr = (c * 1ll * p) % M;	
	while (hashtable[ptr] != -1 && hashtable[ptr] != c) {
		ptr++;
		if (ptr == M)
			ptr = 0;
	}

	if (hashtable[ptr] == -1) {
		hashtable[ptr] = c;
		hashvalue[ptr] = tablesize++;
	}	
	return hashvalue[ptr];
}

int getmagic() {
	memcpy(cnts, cnt, sizeof(int) * c);
	sort(cnts, cnts + c);
	long long hs = 0;

	long long best = w2 * 1ll * n * 1ll * (n - 1) / 2 * (c + 31) / 32;
	long long bestmagic = 0;

	for (int i = 0; i < c; i++) {
		hs += cnts[i] * (cnts[i] - 1) / 2;
		if (i == c - 1 || cnts[i + 1] > cnts[i]) {
			long long cur = w2 * 1ll * n * (n - 1) / 2 * ((c - i - 1 + 31) / 32) + w1 * hs;
			if (cur < best) {
				best = cur;
				bestmagic = cnts[i] + 1;
			}
		}
	}

	return bestmagic;
}

void solve_stupid() {
	set <int> flang;
	for (int i = 0; i < m; i++) {
		int d;
		scanf("%d", &d);
		flang.insert(d);
	}

	int ans = 1;
	for (int i = 0; i < m; i++) {
		int d;
		scanf("%d", &d);

		ans += (flang.find(d) != flang.end());
	}

	printf("%d\n", ans);
}

double start = 0.0;
char buf[size * 20];
int hmas[size];

void reset(string str) {
	cerr << str << ' ' << (clock() - start) / CLOCKS_PER_SEC << endl;
	start = clock();
}

int main() {
	memset(hashtable, -1, sizeof(hashtable));
	scanf("%d%d", &n, &m);

	if (n == 2) {
		solve_stupid();

		return 0;
	}

	for (int i = 0; i < n; i++) {
	    int j = 0;
		fgets(buf, sizeof(buf), stdin);
		int cur = 0;
		int ptr = 0;
		while (buf[ptr]) {
			if (j == m)
				break;
			if (buf[ptr] >= '0' && buf[ptr] <= '9')
				cur = cur * 10 + (buf[ptr] - '0');
			else {
				col[i][j++] = cur;
				cur = 0;
			}

			ptr++;
		}
	}

	reset("reading");

	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++) {
			col[i][j] = getnum(col[i][j]);
			cnt[col[i][j]]++;	
		}	
	reset("hashing");

	c = tablesize;


	if (n > size) {
		for (int i = 0; i < n; i++)
			for (int j = 0; j < m; j++) {
			    int cnum = col[i][j];
				fifth[i][cnum / 32] |= (1u << (cnum & 31));
			}	

		for (int i = 0; i < (1 << 16); i++)
			bc[i] = __builtin_popcount(i);

		int ans = -1;
		for (int i = 0; i < n; i++)
			for (int j = i + 1; j < n; j++) {
				int cur = 0;
				for (int p = 0; p < ssize; p++) {
			    	unsigned int hv = fifth[i][p] & fifth[j][p];
					cur += bc[hv & hmsk] + bc[(hv) >> 16];
				}
		
				ans = max(ans, cur);
			}

		printf("%d\n", ans + 1);


		return 0;
	}


	for (int i = 0; i < c; i++) {
		sum[i + 1] = sum[i] + cnt[i];
		cur[i] = sum[i];
	}

	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			sethave[cur[col[i][j]]++] = i;


	int magic = getmagic();
	cerr << magic << endl;
	reset("get magic");

	int fat = 0;

	for (int i = 0; i < c; i++) {
		if (cnt[i] < magic) {
			int lb = sum[i];
			int rb = sum[i + 1];

			for (int p = lb; p < rb; p++)
				hmas[p - lb] = sethave[p];	
			for (int p = 0; p < rb - lb; p++)
				for (int q = p + 1; q < rb - lb; q++)
					rem[hmas[p]][hmas[q]]++;
		} else {
			fatnum[i] = fat++;
		}
	}
	
	reset("first part");

	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++) {
			int hc = col[i][j];
			if (cnt[hc] >= magic) {
				int fn = fatnum[hc];
				ncol[i][fn / 32] |= (1u << (fn & 31));
			}
		}

	for (int i = 0; i < (1 << 16); i++)
		bc[i] = __builtin_popcount(i);

	int ans = -1;
	for (int i = 0; i < n; i++)
		for (int j = i + 1; j < n; j++) {
			int cur = rem[i][j];
			for (int p = 0; p < (fat + 31) / 32; p++) {
			    unsigned int hv = ncol[i][p] & ncol[j][p];
				cur += bc[hv & hmsk] + bc[(hv) >> 16];
			}
		
			ans = max(ans, cur);
		}
	reset("second part");

	printf("%d\n", ans + 1);


    return 0;
}