/*
  Generate random strings of specified summary length.
  O(n * log^2 L)
*/

#include <iostream>
#include <cstdlib>
#include "testlib.h"

using namespace std;

int n;
int sum_len;

void sample(int n, int k, vector<int> &ans) {
    vector<int> f(n);
    for (int i = 0; i < k; ++i) {
        int x = rnd.next(0, n - i - 1);
        int le = -1, ri = n - 1;
        while (le + 1 < ri) {
            int mi = (le + ri) / 2;
            int s = 0;
            for (int j = mi; j >= 0; j = (j & (j + 1)) - 1) {
                s += f[j];
            }
            if (mi + 1 - s >= x + 1) {
                ri = mi;
            } else {
                le = mi;
            }
        }
        int p = ri;
        ans.push_back(p);
        for (int j = p; j < n; j = (j | (j + 1))) {
            ++f[j];
        }
    }
    sort(ans.begin(), ans.end());
}

int main(int argc, char **argv) {
    registerGen(argc, argv, 1);

    n = atoi(argv[1]);
    sum_len = atoi(argv[2]);

    vector<int> borders;
    borders.push_back(-1);
    borders.push_back(sum_len - 1);
    sample(sum_len - 1, n - 1, borders);
    cout << n << endl;
    char rnd_char = rnd.next("[a-z]")[0];
    for (int i = 0; i < n; ++i) {
        int len = borders[i + 1] - borders[i];
        cout << string(len, rnd_char) << endl;
    }
    return 0;
}
