/*
  Generate random strings with lengths in interval [min_len, max_len].
  O(n * max_len)
*/

#include <iostream>
#include <cstdlib>
#include "testlib.h"

using namespace std;

int n;
int min_len;
int max_len;

void gen_chars(char &a, char &b) {
    vector< pair<char, char> > g;
    for (char i = 'a'; i <= 'z'; ++i) {
        for (char j = 'a'; j <= 'z'; ++j) {
            if (i != j) {
                g.push_back({i, j});
            }
        }
    }
    auto chars = rnd.any(g.begin(), g.end());
    a = chars.first;
    b = chars.second;
}

string gen_rnd_ab(int min_len, int max_len, char a, char b) {
    return rnd.next(format("[%c%c]{%d,%d}", a, b, min_len, max_len));
}

int main(int argc, char **argv) {
    registerGen(argc, argv, 1);

    n = atoi(argv[1]);
    min_len = atoi(argv[2]);
    max_len = atoi(argv[3]);

    char a, b;
    gen_chars(a, b);
    
    cout << n << endl;
    for (int i = 0; i < n; ++i) {
        cout << gen_rnd_ab(min_len, max_len, a, b) << endl;
    }
    return 0;
}
