/*
  Generate random strings of specified summary length.
  O(n * log^2 L)
*/

#include <iostream>
#include <cstdlib>
#include "testlib.h"

using namespace std;

int n;
int sum_len;

void sample(int n, int k, vector<int> &ans) {
    vector<int> f(n);
    for (int i = 0; i < k; ++i) {
        int x = rnd.next(0, n - i - 1);
        int le = -1, ri = n - 1;
        while (le + 1 < ri) {
            int mi = (le + ri) / 2;
            int s = 0;
            for (int j = mi; j >= 0; j = (j & (j + 1)) - 1) {
                s += f[j];
            }
            if (mi + 1 - s >= x + 1) {
                ri = mi;
            } else {
                le = mi;
            }
        }
        int p = ri;
        ans.push_back(p);
        for (int j = p; j < n; j = (j | (j + 1))) {
            ++f[j];
        }
    }
    sort(ans.begin(), ans.end());
}

void gen_chars(char &a, char &b) {
    vector< pair<char, char> > g;
    for (char i = 'a'; i <= 'z'; ++i) {
        for (char j = 'a'; j <= 'z'; ++j) {
            if (i != j) {
                g.push_back({i, j});
            }
        }
    }
    auto chars = rnd.any(g.begin(), g.end());
    a = chars.first;
    b = chars.second;
}

string gen_rnd_ab(int len, char a, char b) {
    return rnd.next(format("[%c%c]{%d}", a, b, len));
}

int main(int argc, char **argv) {
    registerGen(argc, argv, 1);

    n = atoi(argv[1]);
    sum_len = atoi(argv[2]);

    char a, b;
    gen_chars(a, b);
    
    vector<int> borders;
    borders.push_back(-1);
    borders.push_back(sum_len - 1);
    sample(sum_len - 1, n - 1, borders);
    cout << n << endl;
    for (int i = 0; i < n; ++i) {
        int len = borders[i + 1] - borders[i];
        cout << gen_rnd_ab(len, a, b) << endl;
    }
    return 0;
}
