#include <iostream>
#include <algorithm>
#include "testlib.h"

using namespace std;

const vector<int> N_MAX = {100000, 10, 10, 10, 20000, 100000, 100000};
const vector<int> STR_LEN_MAX = {500000, 50, 5000, 20000, 20000, 100000, 500000};
const vector<int> SUM_LEN_MAX = {500000, 50, 5000, 20000, 20000, 100000, 500000};
int group;
int n;
int sum_len;

int main(int argc, char **argv) {
    registerValidation(argc, argv);

    group = atoi(validator.group().data());
    ensuref(0 <= group && group <= 6, "Incorrect test group: %d", group);
    
    n = inf.readInt(1, N_MAX[group], "n");
    inf.readEoln();
    for (int i = 0; i < n; ++i) {
        string s;
        s = inf.readToken(format("[a-z]{1,%d}", STR_LEN_MAX[group]));
        sum_len += (int)s.size();
        inf.readEoln();
    }

    ensuref(sum_len <= SUM_LEN_MAX[group],
            "The summary length of the strings exceeds the limit");
    
    inf.readEof();
    return 0;
}
