import java.io.*;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;

public class MinUniqueSubstr {
    private final InputReader reader;
    private final OutputWriter writer;

    public MinUniqueSubstr(InputReader reader, OutputWriter writer) {
        this.reader = reader;
        this.writer = writer;
    }

    public static void main(String[] args) {
        InputReader reader = new InputReader(System.in);
        OutputWriter writer = new OutputWriter(System.out);
        new MinUniqueSubstr(reader, writer).run();
        writer.writer.flush();
    }

    int[] color;
    char[] S;
    final int MAXL = 1000 * 1000 + 42;

    int[] eq, neq, cnt;
    int[] A, nA;
    int[] iA;
    int[] lcp;
    int[] tillNext;

    void buildSA() {
        int n = S.length;
        A = new int[n];
        nA = new int[n];
        eq = new int[n];
        neq = new int[n];
        cnt = new int[Math.max(28, n)];
        for (int i = 0; i < n; i++) {
            cnt[S[i]]++;
        }
        for (int i = 1; i < 28; i++) {
            cnt[i] += cnt[i - 1];
        }
        for (int i = n - 1; i >= 0; i--) {
            A[--cnt[S[i]]] = i;
        }
        int cls = 0;
        eq[A[0]] = 0;
        for (int i = 1; i < n; i++) {
            cls = eq[A[i]] = (S[A[i]] == S[A[i - 1]]) ? eq[A[i - 1]] : eq[A[i - 1]] + 1;
        }
        for (int k = 1; k < n && cls != n; k <<= 1) {
            Arrays.fill(cnt, 0, cls + 1, 0);
            for (int i = 0; i < n; i++) {
                A[i] -= k;
                if (A[i] < 0)
                    A[i] += n;
                cnt[eq[A[i]]]++;
            }
            for (int i = 1; i <= cls; i++) {
                cnt[i] += cnt[i - 1];
            }
            for (int i = n - 1; i >= 0; i--) {
                nA[--cnt[eq[A[i]]]] = A[i];
            }
            int[] tmp = A;
            A = nA;
            nA = tmp;
            cls = neq[A[0]] = 0;
            for (int i = 1; i < n; i++) {
                int kai = k + A[i];
                int kai1 = k + A[i - 1];
                if (kai >= n) {
                    kai -= n;
                }
                if (kai1 >= n) {
                    kai1 -= n;
                }
                cls = neq[A[i]] = (eq[A[i]] != eq[A[i - 1]] || eq[kai] != eq[kai1]) ? neq[A[i - 1]] + 1 : neq[A[i - 1]];
            }
            tmp = eq;
            eq = neq;
            neq = tmp;
        }
        iA = nA;
        for (int i = 0; i < n; i++)
            iA[A[i]] = i;
        int cur = 0;
        lcp = new int[n];
        for (int i = n; i > 0; i--) {
            int p = iA[n - i];
            if (p + 1 != n) {
                if (cur > 0 && (A[p] + cur - 1 >= n || A[p + 1] + cur - 1 >= n || S[A[p] + cur - 1] != S[A[p + 1] + cur - 1]))
                    throw new AssertionError();
                while (A[p] + cur != n && A[p + 1] + cur != n && S[A[p] + cur] == S[A[p + 1] + cur])
                    cur++;
                lcp[p] = Math.min(cur, Math.min(tillNext[A[p]], tillNext[A[p + 1]]));
                cur = Math.max(0, cur - 1);
            } else {
                cur = 0;
            }
        }
    }
    public void run() {
        int n = reader.nextInt();
        color = new int[MAXL];
        S = new char[MAXL];
        tillNext = new int[MAXL];
        int pt = 0;
        for (int i = 0; i < n; i++) {
            char[] str = reader.next().toCharArray();
            for (int j = 0; j < str.length; j++) {
                S[pt] = str[j];
                color[pt] = i;
                tillNext[pt] = str.length - j;
                pt++;
            }
            S[pt] = 'a' - 1;
            color[pt] = -1;
            tillNext[pt] = 0;
            pt++;
        }
        S[pt++] = 'a' - 2;
        S = Arrays.copyOf(S, pt);
        for (int i = 0; i < pt; i++)
            S[i] -= 'a' - 2;
        color = Arrays.copyOf(color, pt);
        tillNext = Arrays.copyOf(tillNext, pt);
        buildSA();

        int[] L = new int[pt];
        int[] R = new int[pt];
        int[] len = new int[n];
        int[] pos = new int[n];
        Arrays.fill(len, pt + 1);

        for (int l = 0, r = 0; l != pt; l = r) {
            while (r != pt && color[A[r]] == color[A[l]])
                r++;
            if (color[A[l]] == -1)
                continue;
            L[l] = (l == 0) ? 0 : lcp[l - 1];
            for (int i = l + 1; i < r; i++)
                L[i] = Math.min(L[i - 1], lcp[i - 1]);
            R[r - 1] = lcp[r - 1];
            for (int i = r - 2; i >= l; i--)
                R[i] = Math.min(R[i + 1], lcp[i]);
            for (int i = l; i < r; i++) {
                int curlen = Math.max(L[i], R[i]) + 1;
                int curpos = A[i];
                if (curlen >= pt || curlen > tillNext[curpos])
                    continue;
                if (len[color[A[l]]] > curlen) {
                    len[color[A[l]]] = curlen;
                    pos[color[A[l]]] = curpos;
                }
            }
        }

        for (int i = 0; i < n; i++) {
            if (len[i] >= pt || len[i] > tillNext[pos[i]]) {
                writer.printf("?\n");
            } else {
                for (int j = pos[i]; j < pos[i] + len[i]; j++)
                    writer.printf("%c", S[j] + 'a' - 2);
                writer.printf("\n");
            }
        }
    }


    static class InputReader {
        public BufferedReader reader;
        public StringTokenizer tokenizer;

        public InputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream), 32768);
            tokenizer = null;
        }

        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

        public double nextDouble() {
            return Double.parseDouble(next());
        }

        public long nextLong() {
            return Long.parseLong(next());
        }
    }

    static class OutputWriter {
        public PrintWriter writer;

        OutputWriter(OutputStream stream) {
            writer = new PrintWriter(stream);
        }

        public void printf(String format, Object... args) {
            writer.print(String.format(Locale.ENGLISH, format, args));
        }
    }
}

