/*
  Time: O(n + s L)
  Memory: O(n + s L)
*/

#include <iostream>
#include <algorithm>
#include <vector>
#include <unordered_map>

using namespace std;

typedef long long ll;
typedef long double ld;

#define fi first
#define se second
#define mp make_pair
#define pb push_back

const int INF = 1000 * 1000 * 1000 + 5;

struct Substr {
    ll h;
    int l, r, i, j, k;

    Substr() : h(-1), l(INF), r(-INF) {}
};

const int HM_MOD = 10 * 1000 * 1000 - 9;
struct HashMap {
    Substr a[HM_MOD];
    
    Substr& get(ll h) {
        int p = (int)(h % HM_MOD);
        while (a[p].h != -1 && a[p].h != h) {
            ++p;
            if (p == HM_MOD) {
                p = 0;
            }
        }
        a[p].h = h;
        return a[p];
    }
};

const ll MOD = (ll)1000 * 1000 * 1000 * 1000 * 1000 * 1000 + 3;
const ll P = 33;
vector<ll> PW;
int n;
vector<string> a;
HashMap g;
vector<int> f;
vector<string> r;

ll mod(ll x, ll y) {
    ll q = (ll)((ld)x * y / MOD);
    ll r = x * y - q * MOD;
    while (r < 0) {
        r += MOD;
    }
    while (r >= MOD) {
        r -= MOD;
    }
    return r;
}

int main() {
#ifdef HOME
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#else
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    
    cin >> n >> ws;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        getline(cin, a[i]);
    }

    for (int i = 0; i < n; ++i) {
        int m = (int)a[i].size();
        for (int j = 0; j < m; ++j) {
            ll h = 0;
            for (int k = 0; j + k < m; ++k) {
                h = (mod(h, P) + a[i][j + k]) % MOD;
                Substr &x = g.get(h);
                x.l = min(x.l, i);
                x.r = max(x.r, i);
                x.i = i;
                x.j = j;
                x.k = k + 1;
            }
        }
    }
    f.resize(n, INF);
    for (int i = 0; i < HM_MOD; ++i) {
        Substr &x = g.a[i];
        if (x.l == x.r) {
            f[x.l] = min(f[x.l], x.k);
        }
    }
    r.resize(n);
    for (int i = 0; i < HM_MOD; ++i) {
        Substr &x = g.a[i];
        if (x.l == x.r && f[x.l] == x.k) {
            string t = a[x.i].substr(x.j, x.k);
            if (r[x.l].empty() || r[x.l] > t) {
                r[x.l] = t;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        if (r[i].empty()) {
            cout << '?' << '\n';
        } else {
            cout << r[i] << '\n';
        }
    }
    return 0;
}
