/*
  Time: O(n * (L * log L + s^2))
  = O(L (n log L + s))
  Memory: ?
*/

#include <iostream>
#include <algorithm>
#include <vector>
#include <unordered_set>

using namespace std;

typedef long long ll;
typedef long double ld;

#define fi first
#define se second
#define mp make_pair
#define pb push_back

const ll MOD = (ll)1000 * 1000 * 1000 * 1000 * 1000 * 1000 + 3;
const ll P = 31;
vector<ll> PW;
int n;
vector<string> a;
vector< vector<ll> > h;

ll mod(ll x, ll y) {
    ll q = (ll)((ld)x * y / MOD);
    ll r = x * y - q * MOD;
    while (r < 0) {
        r += MOD;
    }
    while (r >= MOD) {
        r -= MOD;
    }
    return r;
}

ll get(int t, int i, int k) {
    return (h[t][i + k] - mod(h[t][i], PW[k]) + MOD) % MOD;
}

bool str_less(int i, int p, int q, int mi) {
    int le = 0, ri = mi;
    while (le < ri) {
        int x = (le + ri + 1) / 2;
        if (get(i, p, x) == get(i, q, x)) {
            le = x;
        } else {
            ri = x - 1;
        }
    }
    return le < mi && a[i][p + le] < a[i][q + le];
}

int main() {
#ifdef HOME
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#else
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    
    cin >> n >> ws;
    a.resize(n);
    int max_len = 0;
    for (int i = 0; i < n; ++i) {
        getline(cin, a[i]);
        max_len = max(max_len, (int)a[i].size());
    }

    PW.resize(max_len + 1);
    PW[0] = 1;
    for (int i = 1; i <= max_len; ++i) {
        PW[i] = mod(PW[i - 1], P);
    }

    h.resize(n);
    for (int i = 0; i < n; ++i) {
        int m = (int)a[i].size();
        h[i].resize(m + 1);
        for (int j = 1; j <= m; ++j) {
            h[i][j] = (mod(h[i][j - 1], P) + (a[i][j - 1] - 'a' + 1)) % MOD;
        }
    }
    for (int i = 0; i < n; ++i) {
        int m = (int)a[i].size();
        int le = 0, ri = m + 1;
        int ri_ans = -1;
        while (ri - le > 1) {
            int x = (le + ri) / 2;
            unordered_set<ll> g;
            for (int t = 0; t < n; ++t) {
                if (t == i) {
                    continue;
                }
                for (int j = 0; j + x <= (int)a[t].size(); ++j) {
                    g.insert(get(t, j, x));
                }
            }
            int p = -1;
            for (int j = 0; j + x <= m; ++j) {
                ll w = get(i, j, x);
                if (g.find(w) == g.end()) {
                    if (p == -1 || str_less(i, j, p, x)) {
                        p = j;
                    }
                }
            }
            if (p != -1) {
                ri = x;
                ri_ans = p;
            } else {
                le = x;
            }
        }
        if (ri_ans == -1) {
            cout << '?' << '\n';
        } else {
            cout << a[i].substr(ri_ans, ri) << '\n';
        }
    }
    return 0;
}
