/*
  Time: O(n * (L * log L + ans_i * s_i))
  Memory: ?
*/

#include <iostream>
#include <algorithm>
#include <vector>
#include <unordered_set>

using namespace std;

typedef long long ll;
typedef long double ld;

#define fi first
#define se second
#define mp make_pair
#define pb push_back

const ll P = 31;
vector<ll> PW;
int n;
vector<string> a;
vector< vector<ll> > h;

ll mod(ll x, ll y) {
    return x * y;
}

ll get(int t, int i, int k) {
    return h[t][i + k] - mod(h[t][i], PW[k]);
}

int main() {
#ifdef HOME
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    
    cin >> n >> ws;
    a.resize(n);
    int max_len = 0;
    for (int i = 0; i < n; ++i) {
        getline(cin, a[i]);
        max_len = max(max_len, (int)a[i].size());
    }

    PW.resize(max_len + 1);
    PW[0] = 1;
    for (int i = 1; i <= max_len; ++i) {
        PW[i] = mod(PW[i - 1], P);
    }

    h.resize(n);
    for (int i = 0; i < n; ++i) {
        int m = (int)a[i].size();
        h[i].resize(m + 1);
        for (int j = 1; j <= m; ++j) {
            h[i][j] = mod(h[i][j - 1], P) + (a[i][j - 1] - 'a' + 1);
        }
    }
    for (int i = 0; i < n; ++i) {
        int m = (int)a[i].size();
        int le = 0, ri = m + 1;
        string ri_ans = "?";
        while (ri - le > 1) {
            int x = (le + ri) / 2;
            unordered_set<ll> g;
            for (int t = 0; t < n; ++t) {
                if (t == i) {
                    continue;
                }
                for (int j = 0; j + x <= (int)a[t].size(); ++j) {
                    g.insert(get(t, j, x));
                }
            }
            string ans;
            for (int j = 0; j + x <= m; ++j) {
                ll w = get(i, j, x);
                if (g.find(w) == g.end()) {
                    string s = a[i].substr(j, x);
                    if (ans.empty() || s < ans) {
                        ans = s;
                    }
                }
            }
            if (!ans.empty()) {
                ri = x;
                ri_ans = ans;
            } else {
                le = x;
            }
        }
        cout << ri_ans << '\n';
    }
    return 0;
}
