/*
  Slow with std::set.
  Time: ?
  O(n * ans_i * n * s_i * ans_i)
  O(n * L * ans_i^2)
  O(L^3 / n)
  Memory: ?
*/

#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <cassert>
#include <cstdio>

using namespace std;

int n;
vector<string> a;

int main() {
#ifdef HOME
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n >> ws;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        getline(cin, a[i]);
    }
    for (int i = 0; i < n; ++i) {
        int m = (int)a[i].size();
        string ans;
        for (int x = 1; x <= m; ++x) {
            for (int j = 0; j + x <= m; ++j) {
                string s = a[i].substr(j, x);
                bool good = true;
                for (int t = 0; t < n && good; ++t) {
                    if (t == i) {
                        continue;
                    }
                    for (int k = 0; k + x <= (int)a[t].size(); ++k) {
                        if (a[t].substr(k, x) == s) {
                            good = false;
                            break;
                        }
                    }
                }
                if (good) {
                    if (ans.empty() || s < ans) {
                        ans = s;
                    }
                }
            }
            if (!ans.empty()) {
                break;
            }
        }
        if (ans.empty()) {
            cout << '?' << '\n';
        } else {
            cout << ans << '\n';
        }
    }
    return 0;
}
