#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cstring>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <list>
#include <deque>
#include <queue>
#include <sstream>
#include <iostream>
#include <algorithm>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const double pi = acos(-1.0);
const int size = 2 * 1000 * 1000;
const int alpha = 26;
const int inf = 1000 * 1000 * 1000;

int way[size][alpha];
int maxlen[size];
int suflink[size];
int cur, alen;

int minlen[size];
int mystring[size];
int minnum[size];
int maxnum[size];
int from[size];
bool used[size];

char buf[size];
int best[size];
int lrnum[size];
char myc[size];
vector <int> sufways[size];

int n;
int curtm = 0;
string alls[size];
int slen[size];

void init() {
	suflink[0] = -1;
	alen = 1;
	cur = 0;
}

void addsmb(int c, int sn) {
    if (way[cur][c] != 0) {
    	int tg = way[cur][c];
		if (maxlen[tg] == maxlen[cur] + 1) {
			cur = tg;
		} else {
			int clone = alen++;
			myc[clone] = char('a' + c);

			mystring[clone] = sn;
			minnum[clone] = min(sn, minnum[tg]);
			maxnum[clone] = max(sn, maxnum[tg]);
			
			maxlen[clone] = maxlen[cur] + 1;
			suflink[clone] = suflink[tg];
			memcpy(way[clone], way[tg], sizeof(int) * alpha);
			suflink[tg] = clone;

			while (cur != -1 && way[cur][c] == tg) {
				way[cur][c] = clone;
				cur = suflink[cur];
			}

			cur = clone;
		}

		return;
    }	

	int nps = alen++;
	maxlen[nps] = maxlen[cur] + 1;
	myc[nps] = char('a' + c);
	mystring[nps] = sn;
	minnum[nps] = sn;
	maxnum[nps] = sn;

	int p = cur;
	while (p != -1 && way[p][c] == 0) {
		way[p][c] = nps;
		p = suflink[p];
	}
	if (p == -1) {
		suflink[nps] = 0;
	} else {
		int tg = way[p][c];
		if (maxlen[tg] == maxlen[p] + 1) {
			suflink[nps] = tg;
		} else {
			int clone = alen++;
			myc[clone] = char('a' + c);

			mystring[clone] = sn;
			minnum[clone] = min(sn, minnum[tg]);
			maxnum[clone] = max(sn, maxnum[tg]);
			
			maxlen[clone] = maxlen[p] + 1;
			suflink[clone] = suflink[tg];
			memcpy(way[clone], way[tg], sizeof(int) * alpha);
			suflink[tg] = clone;
			suflink[nps] = clone;

			while (p != -1 && way[p][c] == tg) {
				way[p][c] = clone;
				p = suflink[p];
			}
		}
	}

	cur = nps;
}

void dfs(int v) {
	used[v] = true;
	
	for (int i = 0; i < alpha; i++)
		if (way[v][i] != 0) {
			if (maxlen[way[v][i]] == maxlen[v] + 1) {
				from[way[v][i]] = v;
			}
		 	if (!used[way[v][i]]) {
				dfs(way[v][i]);
			}
			minnum[v] = min(minnum[v], minnum[way[v][i]]);
			maxnum[v] = max(maxnum[v], maxnum[way[v][i]]);
		}
}

void dfs2(int v) {
    used[v] = true;
	for (int i = 0; i < (int) sufways[v].size(); i++) {
		if (!used[sufways[v][i]])
			dfs2(sufways[v][i]);
		minnum[v] = min(minnum[v], minnum[sufways[v][i]]);		
		maxnum[v] = max(maxnum[v], maxnum[sufways[v][i]]);		
	}
}

void dfs3(int v) {
	lrnum[v] = curtm++;
	for (int i = 0; i < alpha; i++)
		if (minlen[way[v][i]] == minlen[v] + 1)
			dfs3(way[v][i]);
}

int main() {
	scanf("%d", &n);

	for (int i = 0; i < n; i++) {
		scanf("%s", buf);
		alls[i] = string(buf);
		slen[i] = alls[i].size();
	}

	init();	
	for (int i = 0; i < n; i++) {
		scanf("%s", buf);
		for (int j = 0; j < (int) alls[i].size(); j++) {
			addsmb(alls[i][j] - 'a', i);		
			minnum[cur] = min(minnum[cur], i);
			maxnum[cur] = max(maxnum[cur], i); 
		}
		cur = 0;	
	}

	from[0] = -1;

	for (int i = 1; i < alen; i++) {
//	    cerr << "edge " << suflink[i] << ' ' << i << endl;
		sufways[suflink[i]].pb(i);
	}	

	dfs(0);
	for (int i = 0; i < alen; i++)
		used[i] = false;
	dfs2(0);	
	for (int i = 0; i < alen; i++)
		used[i] = false;

    
    for (int i = 0; i < n; i++) {
    	best[i] = -1;
    }
    for (int i = 1; i < alen; i++)
    	minlen[i] = maxlen[suflink[i]] + 1;
    dfs3(0);
    
    for (int i = 0; i < alen; i++)
    	for (int j = 0; j < alpha; j++)
    		if (way[i][j] != 0 && minlen[way[i][j]] == minlen[i] + 1) {
				from[way[i][j]] = i;    			
    		}
    from[0] = -1;
    
    for (int i = 1; i < alen; i++) {
    	if (minnum[i] == maxnum[i]) {
    		int c = minnum[i];
    		if (best[c] == -1 || minlen[best[c]] > minlen[i] || (minlen[best[c]] == minlen[i] && lrnum[i] < lrnum[best[c]])) {
    			best[c] = i;
    		}
    	}
    }

    for (int i = 0; i < n; i++) {
		if (best[i] == -1 || minlen[best[i]] > slen[i]) {
			printf("?\n");
		} else {
			int v = best[i];

			int len = minlen[v];
			buf[len] = 0;
			while (v != 0) {
				buf[len - 1] = myc[v];
				v = from[v];
				len--;
			}
//		 	assert(len == 0);

			printf("%s\n", buf);
		}
    }
/*
    for (int i = 0; i < alen; i++)
    	for (int j = 0; j < alpha; j++) {
    		if (way[i][j] != 0) {
    			cerr << i << ' ' << j << ' ' << way[i][j] << endl;
    		}
    	}
*/
//    for (int i = 0; i < alen; i++) {
//    	cerr << "info: " << i << ' ' << minlen[i] << ' ' << maxlen[i] << ' ' << suflink[i] << ' ' << minnum[i] << ' ' << maxnum[i] << endl;
//    }

    return 0;
}