#include "testlib.h"
#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

int main(int argc, char **argv) {
    registerGen(argc, argv, 1);
    int minN = atoi(argv[1]);
    int maxN = atoi(argv[2]);
    int minK = atoi(argv[3]);
    int maxK = atoi(argv[4]);
    
    int n = rnd.next(minN, maxN);
    while (n % 3 != 1)
        --n;
    
    int k = rnd.next(minK, min(maxK, 2 * (n / 3)));
    
    vector <int> colorStarters;
    for (int i = 0; i < n - 1; i += 3) {
        colorStarters.push_back(i);
    }
    shuffle(colorStarters.begin(), colorStarters.end());
    vector <pair<int, int> > colorStart(n, make_pair(0, 0));
    for (int i = 0; i < k; i += 2) {
        colorStart[colorStarters[i / 2]] = make_pair(i, (i + 1 == k ? 0 : i + 1));
    }
    
    vector <pair<pair<int, int>, int> > edges;
    for (int i = 0; i < n - 1; ++i) {
        if (i % 3 == 0) {
            edges.push_back(make_pair(make_pair(i, i + 1), colorStart[i].first));
            edges.push_back(make_pair(make_pair(i, i + 2), colorStart[i].second));
        } else {
            int start = (i / 3 + 1) * 3;
            edges.push_back(make_pair(make_pair(start, i), (i % 3 == 1 ? colorStart[start - 3].second : colorStart[start - 3].first)));
        }
    }
    shuffle(edges.begin(), edges.end());
    vector <int> vp(n);
    for (int i = 0; i < n; ++i)
        vp[i] = i;
    shuffle(vp.begin(), vp.end());
    vector <int> cp(k + 1);
    for (int i = 1; i <= k; ++i)
        cp[i] = i;
    cp[0] = 0;
    shuffle(cp.begin() + 1, cp.end());
    printf("%d %d %d\n", n, edges.size(), k);
    for (int i = 0; i < edges.size(); ++i) {
        if (rnd.next(1, 2) == 1)
            swap(edges[i].first.first, edges[i].first.second);
        printf("%d %d %d\n", vp[edges[i].first.first] + 1, vp[edges[i].first.second] + 1, cp[edges[i].second]);
    }
    printf("%d %d\n", vp[0] + 1, vp[n - 1] + 1);
    return 0;
}