#include "testlib.h"
#include <vector>
#include <cstdlib>
#include <algorithm>

using namespace std;

pair<int, int> sorted(pair<int, int> x) {
    if (x.first > x.second) {
        swap(x.first, x.second);
    }
    return x;
}

pair<int, int> dist(int n) {
    int a = rnd.next(1, n);
    int b = rnd.next(1, n);
    while (b == a)
        b = rnd.next(1, n);
    return sorted(make_pair(a, b));
}

vector <pair<int, int> > edges;

int main(int argc, char **argv) {                                                                                                                                                                                                
    registerGen(argc, argv, 1);
    int minN = atoi(argv[1]);
    int maxN = atoi(argv[2]);
    int minK = atoi(argv[3]);
    int maxK = atoi(argv[4]);
    int minRK = atoi(argv[5]);
    int maxRK = atoi(argv[6]);
    int n = rnd.next(minN, maxN);
    int k = rnd.next(minK, maxK);
    int rk;
    if (minRK > k)
        rk = k;
    else
        rk = rnd.next(minRK, min(maxRK, k));
    
    int m = 1;
    printf("%d %d %d\n", n, m, k);
    
    pair<int, int> x = dist(n), y = dist(n);
    while (x.first == y.first && x.second == y.second) {
        y = dist(n);
    }
    if (rnd.next(1, 2) == 1) {
        swap(x.first, x.second);
    }
    
    if (rnd.next(1, 2) == 1) {
        swap(y.first, y.second);
    }
    printf("%d %d %d\n", x.first, x.second, rnd.next(0, rk));
    printf("%d %d\n", y.first, y.second);
    return 0;
}