#include "testlib.h"
#include <vector>
#include <algorithm>
#include <utility>
#include <map>

using namespace std;

vector <map<int, int> > g;

int main(int argc, char **argv) {
    registerTestlibCmd(argc, argv);
    int n = inf.readInt();
    int m = inf.readInt();
    int k = inf.readInt();
    g.resize(n);
    for (int i = 0; i < m; ++i) { 
        int a = inf.readInt(), b = inf.readInt(), c = inf.readInt();
        --a, --b;
        g[a][b] = c;
        g[b][a] = c;
    }
    int A = inf.readInt();
    int B = inf.readInt();
    string juryAns = ans.readString();
    string contestantAns = ouf.readString();
    if (contestantAns == "YES") {
        int p = ouf.readInt(2, n);
        int previousCity = ouf.readInt(1, n, "first city in a path");
        if (previousCity != A) {
            quitf(_wa, "path should start with the North capital");
        }
        --previousCity;
        vector <bool> used(k, 0);
        vector <bool> citiesUsed(n, 0);
        citiesUsed[previousCity] = true;
        for (int i = 1; i < p; ++i) {
            int currentCity = ouf.readInt(1, n, "city in a path");
            --currentCity;
            map<int, int>::iterator it = g[previousCity].find(currentCity);
            if (it == g[previousCity].end()) {
                quitf(_wa, "no such road %d %d", previousCity + 1, currentCity + 1);
            }
            if (it->second)
                used[it->second - 1] = true;
            previousCity = currentCity;
            if (citiesUsed[previousCity])
                quitf(_wa, "not a simple path");
            citiesUsed[previousCity] = true;
        }
        if (previousCity != B - 1) {
            quitf(_wa, "path should end in the South capital");
        }
        int missing = -1;
        for (int i = 0; i < k; ++i)
            if (!used[i]) {
                missing = i + 1;
            }
        
        if (missing == -1) {
            quitf(_wa, "All companies are represented on a given path");
        }
        
        if (juryAns == "NO") {
            quitf(_fail, "Contestant found a correct unfair path");
        }
        quitf(_ok, "%d company is missing\n", missing);
    } else if (contestantAns == "NO") {
        if (contestantAns == juryAns)
            quitf(_ok, "everything is fair");
        else 
            quitf(_wa, "there is an unfair path");
    } else {
        quitf(_pe, "first line should be either YES or NO");
    }
    quitf(_fail, "check should have ended");
}