#include "testlib.h"
#include <vector>
#include <cstdlib>
#include <algorithm>

using namespace std;

pair<int, int> sorted(pair<int, int> x) {
    if (x.first > x.second) {
        swap(x.first, x.second);
    }
    return x;
}

pair<int, int> dist(int n) {
    int a = rnd.next(1, n);
    int b = rnd.next(1, n);
    while (b == a)
        b = rnd.next(1, n);
    return sorted(make_pair(a, b));
}

vector <pair<int, int> > edges;

int main(int argc, char **argv) {                                                                                                                                                                                                
    registerGen(argc, argv, 1);
    int minN = atoi(argv[1]);
    int maxN = atoi(argv[2]);
    int minK = atoi(argv[3]);
    int maxK = atoi(argv[4]);
    int ans = atoi(argv[5]);
    while (true) {
        int n = rnd.next(minN, maxN);
        int k = rnd.next(minK, maxK);
        vector <pair<int, int> > edges(n);
        for (int i = 0; i < n; ++i) {
            edges[i] = make_pair(i, (i + 1) % n);
        }
        vector <int> color(n);
        for (int i = 0; i < n; ++i) {
            color[i] = rnd.next(0, k);
        }
        int A, B;
        A = rnd.next(0, n - 1);
        B = rnd.next(0, n - 1);
        while (B == A)
            B = rnd.next(0, n - 1);
        if (A > B)
            swap(A, B);
        if (ans) {
            if (B - A < k || n + A - B < k)
                continue;
            vector <int> good1, good2;
            for (int i = A; i < B; ++i) {
                good1.push_back(i);
            }
            for (int i = B; i != A; i = (i + 1) % n) {
                good2.push_back(i);
            }
            shuffle(good1.begin(), good1.end());
            shuffle(good2.begin(), good2.end());
            for (int i = 0; i < k; ++i) {
                color[good1[i]] = i;
                color[good2[i]] = i;
            }
        } else {
            for (int i = 0; i < n; ++i) {
                color[i] = rnd.next(0, k);
            }
            if (rnd.next(1, 2) == 1) {
                for (int i = A; i < B; ++i) {
                    color[i] = rnd.next(0, k - 1);
                }
            } else {
                for (int i = B; i != A; i = (i + 1) % n) {
                    color[i] = rnd.next(0, k - 1);
                }
            }
        }
        vector<int> vp(n);
        for (int i = 0; i < n; ++i) {
            vp[i] = i + 1;
        }
        vector <int> ep(n);
        for (int i = 0; i < n; ++i) {
            ep[i] = i;
        }
        vector <int> cp(k);
        for (int i = 0; i < k; ++i) {
            cp[i] = i + 1;
        }
        shuffle(cp.begin(), cp.end());
        shuffle(ep.begin(), ep.end());
        shuffle(vp.begin(), vp.end());
        printf("%d %d %d\n", n, n, k);
        for (int i = 0; i < n; ++i) {
            if (rnd.next(1, 2) == 1) {
                swap(edges[ep[i]].first, edges[ep[i]].second);
            }
            printf("%d %d %d\n", vp[edges[ep[i]].first], vp[edges[ep[i]].second], (color[ep[i]] == 0 ? 0 : cp[color[ep[i]] - 1]));
        }
        printf("%d %d\n", vp[A - 1], vp[B - 1]);
        return 0;
    }
}