#include "testlib.h"
#include <vector>
#include <cstdlib>
#include <algorithm>

using namespace std;

pair<int, int> sorted(pair<int, int> x) {
    if (x.first > x.second) {
        swap(x.first, x.second);
    }
    return x;
}

int main(int argc, char **argv) {                                                                                                                                                                                                
    registerGen(argc, argv, 1);
    int minN = atoi(argv[1]);
    int maxN = atoi(argv[2]);
    int minM = atoi(argv[3]);
    int maxM = atoi(argv[4]);
    int minK = atoi(argv[5]);
    int maxK = atoi(argv[6]);
    int minRK = atoi(argv[7]);
    int maxRK = atoi(argv[8]);
    int k = rnd.next(minK, maxK);
    int rk;
    if (minRK > k)
        rk = k;
    else
        rk = rnd.next(minRK, min(maxRK, k));
    
    int n = rnd.next(minN, maxN);
    int sizeOfFirst = rnd.next(1, n - 1);
    int sizeOfSecond = n - sizeOfFirst;
    set<pair<int, int> > g;
    long long maxEdges = min(1ll * sizeOfFirst * (sizeOfFirst - 1) / 2 + 1ll * sizeOfSecond * (sizeOfSecond - 1) / 2, 1ll * rnd.next(minM, maxM));
    
    for (int i = 0; i < maxEdges; ++i) {
        if (rnd.next(1, n) <= sizeOfFirst) {
            int a = rnd.next(0, sizeOfFirst - 1);
            int b = rnd.next(0, sizeOfFirst - 1);
            if (a == b) {
                --i;
                continue;
            } 
            if (g.find(sorted(make_pair(a, b))) != g.end()) {
                --i;
                continue;
            }
            g.insert(sorted(make_pair(a, b)));
        } else {
            int a = rnd.next(sizeOfFirst, n - 1);
            int b = rnd.next(sizeOfFirst, n - 1);
            if (a == b) {
                --i;
                continue;
            } 
            if (g.find(sorted(make_pair(a, b))) != g.end()) {
                --i;
                continue;
            }
            g.insert(sorted(make_pair(a, b)));
        }
    }
    
    vector <int> vp(n);
    for (int i = 0; i < n; ++i) {
        vp[i] = i;
    }
    shuffle(vp.begin(), vp.end());
    
    printf("%d %d %d\n", n, g.size(), k);
    for (set<pair<int, int> >::iterator it = g.begin(); it != g.end(); ++it) {
        printf("%d %d %d\n", vp[it->first] + 1, vp[it->second] + 1, rnd.next(0, rk));
    }
    
    printf("%d %d\n", vp[0] + 1, vp[n - 1] + 1);
    return 0;
    
}
    