#include "testlib.h"
#include <vector>
#include <cstdlib>
#include <algorithm>

using namespace std;

pair<int, int> sorted(pair<int, int> x) {
    if (x.first > x.second) {
        swap(x.first, x.second);
    }
    return x;
}

pair<int, int> dist(int n) {
    int a = rnd.next(1, n);
    int b = rnd.next(1, n);
    while (b == a)
        b = rnd.next(1, n);
    return sorted(make_pair(a, b));
}

vector <pair<int, int> > edges;

int main(int argc, char **argv) {                                                                                                                                                                                                
    registerGen(argc, argv, 1);
    int minN = atoi(argv[1]);
    int maxN = atoi(argv[2]);
    int minK = atoi(argv[3]);
    int maxK = atoi(argv[4]);
    int mode = atoi(argv[5]); // 0 - both ends, 1 - left end, 2 - right end, 4 - middle
    int ans = atoi(argv[6]);
    while (true) {
        int n = rnd.next(minN, maxN);
        int k = rnd.next(minK, maxK);
        vector <pair<int, int> > edges(n - 1);
        for (int i = 1; i < n; ++i) {
            edges[i - 1] = make_pair(i, i + 1);
        }
        int A, B;
        if (mode == 0) {
            A = 1;
            B = n;
        } else if (mode == 1) {
            A = 1;
            B = rnd.next(2, n - 1);
        } else if (mode == 2) {
            A = rnd.next(2, n - 1);
            B = n;
        } else {
            A = rnd.next(2, n - 1);
            B = rnd.next(2, n - 1);
            while (B == A) {
                B = rnd.next(2, n - 1);
            }
            if (B < A) {
                swap(A, B);
            }
        }
        
        vector <int> cp(k);
        for (int i = 0; i < k; ++i) {
            cp[i] = i + 1;
        }
        shuffle(cp.begin(), cp.end());
        if (ans && B - A < k) {
            continue;
        }
        vector <int> vp(n);
        for (int i = 0; i < n; ++i) {
            vp[i] = i + 1;
        }
        shuffle(vp.begin(), vp.end());
        vector <int> color(n - 1);
        for (int i = 0; i + 1 < n; ++i) {
            color[i] = rnd.next(0, k);
        }
        if (!ans) {
            for (int i = A - 1; i + 1 < B; ++i) {
                color[i] = rnd.next(0, k - 1);
            }
            
        } else {
            vector <int> good(B - A);
            for (int i = A - 1; i < B - 1; ++i) {
                good[i - A + 1] = i;
            }
            shuffle(good.begin(), good.end());
            for (int i = 0; i < k; ++i) {
                color[good[i]] = i + 1;
            }
        }
        vector <int> ep(n - 1);
        for (int i = 0; i < n - 1; ++i) {
            ep[i] = i;
        }
        shuffle(ep.begin(), ep.end());
        printf("%d %d %d\n", n, n - 1, k);
        for (int i = 0; i < n - 1; ++i) {
            if (rnd.next(1, 2) == 1) {
                swap(edges[ep[i]].first, edges[ep[i]].second);
            }
            printf("%d %d %d\n", vp[edges[ep[i]].first - 1], vp[edges[ep[i]].second - 1], (color[ep[i]] == 0 ? 0 : cp[color[ep[i]] - 1]));
        }
        printf("%d %d\n", vp[A - 1], vp[B - 1]);
        return 0;
    }
}