#include "testlib.h"
#include <vector>
#include <cstdlib>
#include <algorithm>

using namespace std;

pair<int, int> sorted(pair<int, int> x) {
    if (x.first > x.second) {
        swap(x.first, x.second);
    }
    return x;
}

int main(int argc, char **argv) {                                                                                                                                                                                                
    registerGen(argc, argv, 1);
    int minN = atoi(argv[1]);
    int maxN = atoi(argv[2]);
    int maxM = atoi(argv[3]);
    int minDist = atoi(argv[4]);
    int maxDist = atoi(argv[5]);
    int minK = atoi(argv[6]);
    int maxK = atoi(argv[7]);
    int k = rnd.next(minK, maxK);
    int dist;
    int n;
    set<pair<pair<int, int>, int> > edges;
    do {
        edges.clear();
        n = rnd.next(minN, maxN);
        dist = rnd.next(minDist, min(maxDist, n - 1));
        vector <vector<int> > layers(dist + 1);
        layers[0].push_back(0);
        for (int i = 1; i <= dist; ++i) {
            int first = layers[i - 1].back() + 1;
            int last = (i == dist ? n - 1 : rnd.next(first, n - (dist - i) - 1));
            for (int j = first; j <= last; ++j) {
                layers[i].push_back(j);
            }
        }
        long long possible = 0;
        for (int layer = 1; layer <= dist; ++layer) {
            for (int j = 0; j < layers[layer].size(); ++j) {
                int parent = layers[layer - 1][rnd.next(0, (int)layers[layer - 1].size() - 1)];
                int ancestor = layers[layer][j];
                edges.insert(make_pair(sorted(make_pair(ancestor, parent)), layer - 1));
            }
            possible = 1ll * layers[layer].size() * layers[layer - 1].size();
        }
        while (edges.size() < min(1ll * maxM, possible)) {
            int i, j;
            int layer;
            if (rnd.next(0, 1) == 0) {
                layer = rnd.next(0, dist);
                i = layers[layer][rnd.next(0, (int)layers[layer].size() - 1)];
                j = layers[layer][rnd.next(0, (int)layers[layer].size() - 1)];
            } else {
                layer = rnd.next(0, dist - 1);
                i = layers[layer][rnd.next(0, (int)layers[layer].size() - 1)];
                j = layers[layer + 1][rnd.next(0, (int)layers[layer].size() - 1)];                    
            }
            if (i != j) {
                edges.insert(make_pair(sorted(make_pair(i, j)), layer + 1));
            }
        
        }
    } while (edges.size() > maxM || k > dist);
    vector <int> vp(n);
    for (int i = 0; i < n; ++i)
        vp[i] = i;
    shuffle(vp.begin(), vp.end());
    vector <int> cp(k);
    for (int i = 0; i < k; ++i)
        cp[i] = i;
    shuffle(cp.begin(), cp.end());
    printf("%d %d %d\n", n, (int)edges.size(), k);
    for (set<pair<pair<int, int>, int> >::iterator it = edges.begin(); it != edges.end(); ++it) {
        printf("%d %d %d\n", vp[it->first.first] + 1, vp[it->first.second] + 1 , (it->second >= k ? rnd.next(0, k) : cp[it->second] + 1));
    }
    printf("%d %d\n", vp[0] + 1, vp[n - 1] + 1);
    return 0;
}