#include "testlib.h"
#include <vector>
#include <set>

using namespace std;

const int MAXN[] = {100 * 1000, 1000, 1000, 100 * 1000};
const int MAXK[] = {100 * 1000, 2, 1000, 100 * 1000};

int main(int argc, char** argv) {
    registerValidation(argc, argv);
    int group = atoi(validator.group().data());
    ensuref(0 <= group && group <= 3, "Incorrect test group %d", group);
    int n = inf.readInt(2, MAXN[group], "n");
    inf.readSpace();
    int m = inf.readInt(1, MAXN[group], "m");
    inf.readSpace();
    int k = inf.readInt(2, MAXK[group], "k");
    inf.readEoln();
    vector<set<int> > g(n);
    for (int i = 0; i < m; ++i)  {
        int a = inf.readInt(1, n, "a_i");
        inf.readSpace();
        int b = inf.readInt(1, n, "b_i");
        inf.readSpace();
        int c = inf.readInt(0, k, "color_i");
        ensuref(a != b, "loop found: %d", a);
        --a, --b;
        ensuref(g[a].find(b) == g[a].end(), "multiple roads between %d %d", a + 1, b + 1);
        g[a].insert(b);
        g[b].insert(a);
        inf.readEoln();
    }
    int A = inf.readInt(1, n);
    inf.readSpace();
    int B = inf.readInt(1, n);
    ensuref(A != B, "North and South capital should be different");
    inf.readEoln();
    inf.readEof();
    return 0;
}