#include <cstdio>
#include <vector>
#include <algorithm>
#include <queue>
#include <climits>

using namespace std;

int n, m, k;
vector <vector<pair<int, int> > > g;
int A, B;
int number;
vector <bool> used;

bool dfs(int v) {
    used[v] = true;
    if (v == A) {
        return true;
    }
    for (auto const &u: g[v]) {
        if (u.second != number && !used[u.first]) {
            if (dfs(u.first)) {
                return true;
            }
        }
    }
    return false;
}

int main() {
    scanf("%d %d %d", &n, &m, &k);
    g.resize(n);
    vector <int> count(k + 1, 0);
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        scanf("%d %d %d", &a, &b, &c);
        --a, --b;
        g[a].push_back(make_pair(b, c));
        g[b].push_back(make_pair(a, c));
        ++count[c];
    }
    scanf("%d %d", &A, &B);
    --A, --B;
    used.assign(n, 0);
    number = -1;
    bool connected = dfs(B);
    if (!connected) {
        printf("0\n");
        return 0;
    }
    vector <int> answer;
    for (int i = 1; i <= k; ++i) {
        number = i;
        used.assign(n, false);
        if (!count[i] || dfs(B)) {
            answer.push_back(i);
        }
    }
    sort(answer.begin(), answer.end());
    printf("%d\n", answer.size());
    for (int i = 0; i < answer.size(); ++i) {
        printf("%d ", answer[i]);
    }
    printf("\n");
    return 0;
}