#include <cstdio>
#include <vector>
#include <algorithm>
#include <queue>
#include <climits>
#include <queue>
#include <climits>


using namespace std;

int n, m, k;
vector <vector<pair<int, int> > > g;
int A, B;

vector <bool> used;
bool scs = false;

bool dfs(int v, int c, int d) {
    used[v] = true;
    if (v == A) {
        printf("YES\n");
        scs = true;
        printf("%d\n", d);
        printf("%d ", v + 1);
        return true;
    }
    for (int i = 0; i < g[v].size(); ++i) {
        if (g[v][i].second != c) {
            int u = g[v][i].first;
            if (!used[u]) {
                if (dfs(u, c, d + 1)) {
                    printf("%d ", v + 1);
                    return true;
                }
            }
        }
    }
    return false;
}

int main() {
    scanf("%d %d %d", &n, &m, &k);
    g.resize(n);
    
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        scanf("%d %d %d", &a, &b, &c);
        --a, --b;
        g[a].push_back(make_pair(b, c));
        g[b].push_back(make_pair(a, c));
    }
    scanf("%d %d", &A, &B);
    --A, --B;
    queue<int> q;
    vector <int> dist(n, INT_MAX);
    dist[A] = 0;
    q.push(A);
    vector<bool> colors(k, false);
    used.assign(n, false);
    while (q.size()) {
        int v = q.front();
        q.pop();
        for (int i = 0; i < g[v].size(); ++i) {
            int u = g[v][i].first;
            if (dist[u] > dist[v] + 1) {
                dist[u] = dist[v] + 1;
                q.push(u);
            }
        }
    }
    
    if (dist[B] == INT_MAX) {
        printf("0\n");
        return 0;
    }
    
    vector <vector <int> > layers(dist[B] + 1);
    
    for (int i = 0; i < n; ++i) {
        if (dist[i] < dist[B]) {
            layers[dist[i]].push_back(i);
        }
    }
    layers[dist[B]].push_back(B);
    for (int i = 0; i < dist[B]; ++i) {
        int cc = -1;
        for (int j = 0; j < layers[i].size(); ++j) {
            int u = layers[i][j];
            for (int z = 0; z < g[u].size(); ++z) {
                int v = g[u][z].first;
                if (dist[u] + 1 == dist[v] && (dist[v] != dist[B] || v == B)) {
                    if (cc != -1) {
                        if (g[u][z].second != cc) {
                            cc = 0;
                        }
                    } else {
                        cc = g[u][z].second;
                    }
                }
            }
        }
        if (cc >= 1) {
            colors[cc - 1] = true;
        }
    }
    vector <int> answer;
    for (int i = 0; i < k; ++i) {
        if (!colors[i]) {
            answer.push_back(i);
        }
    }
    sort(answer.begin(), answer.end());
    
    printf("%d\n", answer.size());
    for (int i = 0; i < answer.size(); ++i) {
        printf("%d ", answer[i] + 1);
    }
    printf("\n");
    return 0;
}