#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cstring>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <list>
#include <deque>
#include <queue>
#include <sstream>
#include <iostream>
#include <algorithm>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define rank sfkldf

const double pi = acos(-1.0);
const int size = 1000 * 1000 + 100;
const int inf = 1000 * 1000 * 1000;

int par[size];
int rank[size];
vector <pair <int, int> > history;

int getpar(int v) {
	while (par[v] != v)
		v = par[v];
	return v;
}

void unite(int v, int u) {
//	cerr << "unite " << v << ' ' << u << endl;
	v = getpar(v);
	u = getpar(u);
	if (rank[v] < rank[u])
		swap(v, u);
	if (v != u) {
	    history.pb(mp(u, rank[v]));
	    rank[v] += (rank[v] == rank[u]);
		par[u] = v;	
	}
}

void rollback(int mt) {
	while ((int) history.size() > mt) {
		int v = history.back().fs;
		int r = history.back().sc;
		rank[par[v]] = r;
		par[v] = v;

		history.pop_back();
	}
}

int n, m, k;
vector <int> cedges[size];
vector <pair <int, int> > events;
int v[size], u[size], c[size];
int any = -1;
int a, b;
int mom[size];
bool ans[size];

void rec(int lb, int rb) {
	if (lb == rb) {
		if (events[lb].fs == 1) {
//			cerr << lb << ' ' << getpar(a) << ' ' << getpar(b) << endl;
			ans[events[lb].sc] = (getpar(a) != getpar(b));			
		}

		return;
	}

	int mid = (lb + rb) / 2;
	int rem = history.size();
	for (int i = lb; i <= mid; i++)
		if (events[i].fs == 0 && mom[i] > rb) {
			unite(v[events[i].sc], u[events[i].sc]);
		}
	rec(mid + 1, rb);
	rollback(rem);

	for (int i = mid + 1; i <= rb; i++)
		if (events[i].fs == 2 && mom[i] < lb) {
			unite(v[events[i].sc], u[events[i].sc]);
		}
	rec(lb, mid);
	rollback(rem);
}

int main() {
	scanf("%d%d%d", &n, &m, &k);
	for (int i = 0; i < m; i++) {
		scanf("%d%d%d", &v[i], &u[i], &c[i]);
		v[i]--, u[i]--;
		cedges[c[i]].pb(i);
	}
	for (int i = 0; i < m; i++)
		events.pb(mp(0, i));

	scanf("%d%d", &a, &b);
	a--, b--;

	for (int i = 1; i <= k; i++) {
		for (int j = 0; j < (int) cedges[i].size(); j++)
			events.pb(mp(2, cedges[i][j]));
		events.pb(mp(1, i));	
		for (int j = 0; j < (int) cedges[i].size(); j++)
			events.pb(mp(0, cedges[i][j]));
	}

	map <int, int> last;
	for (int i = 0; i < m; i++)
		last[i] = -1;
	for (int i = 0; i < (int) events.size(); i++) {
		if (events[i].fs == 1)
			continue;
		if (last[events[i].sc] == -1) {
			last[events[i].sc] = i;
		} else {
			mom[last[events[i].sc]] = i;
			mom[i] = last[events[i].sc];
			last[events[i].sc] = -1;
		}
	}
	for (int i = 0; i < m; i++)
		if (last[i] != -1)
			mom[last[i]] = inf;

	for (int i = 0; i < n; i++)
		par[i] = i;
//	for (int i = 0; i < (int) events.size(); i++)
//		cerr << "event " << i << ' ' << events[i].fs << ' ' << events[i].sc << ' ' << mom[i] << endl;
	rec(0, (int) events.size() - 1);

	/*
	if (any == -1) {
		printf("NO\n");
	} else {
		printf("YES\n");
		dfs(a, b, any);
		reverse(path.begin(), path.end());
		printf("%d\n", (int) path.size());
		for (int i = 0; i < (int) path.size(); i++)
			printf("%d ", path[i]);
		printf("\n");
	}
	*/
	int cnt = 0;
	for (int i = 1; i <= k; i++)
		cnt += !ans[i];

	printf("%d\n", cnt);
	for (int i = 1; i <= k; i++)
		if (!ans[i])
			printf("%d ", i);
	printf("\n");

    return 0;
}