#include "testlib.h"

#include <cassert>
#include <vector>
#include <string>
using namespace std;

#define mp make_pair

bool IsPalindrom(const string& s) {
  for (int i = 0; i < (int)s.size(); ++i) {
    if (s[i] != s[(int)s.size() - i - 1]) {
      return false;
    }
  }
  return true;
}

bool IsSubsequence(const string& S, const string& T) {
  int tpos = 0;
  for (int i = 0; i < (int)S.size(); ++i) {
    while (tpos < (int)T.size() && S[i] != T[tpos]) {
      ++tpos;
    }
    if (tpos == (int)T.size()) {
      return false;
    } else {
      ++tpos;
    }
  }
  return true;
}

int main(int argc, char* argv[]) {
  registerTestlibCmd(argc, argv);

  const int user_number_of_added_letters = ouf.readInt();
  const int jury_number_of_added_letters = ans.readInt();

  const string S = inf.readWord();
  const string user_palindrom = ouf.readWord();
  if (!IsPalindrom(user_palindrom)) {
    quitf(_wa, "found %s is not a palindrom",
          user_palindrom.c_str());
  }
  if ((int)user_palindrom.size() - (int)S.size() !=
      user_number_of_added_letters) {
    quitf(_wa, "found number of added letters: %d, difference of lengths: %d",
          user_number_of_added_letters,
          (int)user_palindrom.size() - (int)S.size());
  }

  if (!IsSubsequence(S, user_palindrom)) {
    quitf(_wa, "input string %s is not a subsequence of found string %s",
          S.c_str(), user_palindrom.c_str());
  }

  if (user_number_of_added_letters != jury_number_of_added_letters) {
    if (user_number_of_added_letters < jury_number_of_added_letters) {
      quitf(_fail, "Contestant found a better answer: %d; expected answer: %d",
            user_number_of_added_letters, jury_number_of_added_letters);
    } else {
      quitf(_wa, "expected %d added letters, found %d",
            jury_number_of_added_letters, user_number_of_added_letters);
    }
  }

  quitf(_ok, "found %d, %s",
        user_number_of_added_letters, user_palindrom.c_str());
  return 0;
}
