#include "testlib.h"

#include <string>
using namespace std;

static const int kMaxStringLength = 15000;
static const char kMinLetter = 'a';
static const char kMaxLetter = 'z';

const int NUMBER_OF_GROUPS = 7;
const int MAX_ALPHABET[NUMBER_OF_GROUPS] = {2, 2, 26, 26, 26, 26, 26};
const int MAX_LENGTH[NUMBER_OF_GROUPS] = {4, 4, 300, 1000, 5000, 10000, 15000};

int main(int argc, char* argv[]) {
  registerValidation(argc, argv);
  int group = atoi(validator.group().data());
  ensuref(0 <= group && group < NUMBER_OF_GROUPS, "Incorrect test group");

  const string S = inf.readWord();
  if (group == 0) {
      ensure(S == "ab" || S == "abba");
  }

  ensure(S.size() <= MAX_LENGTH[group]);
  for (int i = 0; i < (int)S.size(); ++i) {
    ensure(kMinLetter <= S[i] && S[i] < kMinLetter + MAX_ALPHABET[group]);
  }

  inf.readEoln();
  inf.readEof();
  return 0;
}
