import java.io.*;
import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.StringTokenizer;

public class sol_il_java {
    FastScanner in;
    PrintWriter out;

    static int kAlphabetSize = 300;

    boolean IsPalindrom(String s) {
        for (int i = 0; i < s.length(); ++i) {
            if (s.charAt(i) != s.charAt(s.length() - i - 1)) {
                return false;
            }
        }
        return true;
    }

    String Input() {
        return in.next();
    }

    int[] LCS_last(String s, String t) {
        int[] prev = new int[t.length() + 1];
        int[] next = new int[t.length() + 1];
        Arrays.fill(prev, 0);
        Arrays.fill(next, 0);
        for (int i = 1; i <= s.length(); ++i) {
            for (int j = 1; j <= t.length(); ++j) {
                next[j] = Math.max(prev[j], next[j - 1]);
                if (s.charAt(i - 1) == t.charAt(j - 1)) {
                    next[j] = Math.max(next[j], prev[j - 1] + 1);
                }
            }
            prev = next.clone();
        }
        return prev;
    }

    int FindSplitPosition(String s, String t) {
        int[] lcs_last = LCS_last(s, t);
        int lcs_length = lcs_last[t.length()];

        int[] lcs_left_last = LCS_last(s.substring(0, s.length() / 2), t);

        String right_s = new StringBuilder(s.substring(s.length() / 2)).reverse().toString();

        String reversed_t = new StringBuilder(t).reverse().toString();

        int[] lcs_right_last = LCS_last(right_s, reversed_t);

        for (int i = 0; i <= t.length(); ++i) {
            if (lcs_left_last[i] + lcs_right_last[t.length() - i] == lcs_length) {
                return i;
            }
        }
        return -1;
    }

    Pair<ArrayList<Integer>, ArrayList<Integer>> LCS(String s, String t) {
        Pair<ArrayList<Integer>, ArrayList<Integer>> positions =
                new Pair<ArrayList<Integer>, ArrayList<Integer>>(new ArrayList<Integer>(), new ArrayList<Integer>());

        if (s.length() <= 1 || t.length() <= 1) {
            if (s.length() == 1) {
                for (int i = 0; i < t.length(); ++i) {
                    if (s.charAt(0) == t.charAt(i)) {
                        positions.first.add(0);
                        positions.second.add(i);
                        break;
                    }
                }
            } else if (t.length() == 1) {
                for (int i = 0; i < s.length(); ++i) {
                    if (s.charAt(i) == t.charAt(0)) {
                        positions.first.add(i);
                        positions.second.add(0);
                        break;
                    }
                }
            }
            return positions;
        } else {
            int split_position = FindSplitPosition(s, t);

            positions = LCS(s.substring(0, s.length() / 2), t.substring(0, split_position));

            Pair<ArrayList<Integer>, ArrayList<Integer>> right_positions =
                    LCS(s.substring(s.length() / 2), t.substring(split_position));

            for (int i = 0; i < right_positions.first.size(); ++i) {
                right_positions.first.set(i, right_positions.first.get(i) + s.length() / 2);
            }
            for (int i = 0; i < right_positions.second.size(); ++i) {
                right_positions.second.set(i, right_positions.second.get(i) + split_position);
            }

            positions.first.addAll(right_positions.first);
            positions.second.addAll(right_positions.second);

            return positions;
        }
    }

    void LCS(String s, String t,
             ArrayList<Integer> s_positions, ArrayList<Integer> t_positions) {
        Pair<ArrayList<Integer>, ArrayList<Integer>> positions = LCS(s, t);
        s_positions.addAll(positions.first);
        t_positions.addAll(positions.second);
    }

    String MergeStrings(String s, String t) {
        ArrayList<Integer> s_positions = new ArrayList<Integer>();
        ArrayList<Integer> t_positions = new ArrayList<Integer>();
        LCS(s, t, s_positions, t_positions);
        int s_ptr = 0;
        int t_ptr = 0;
        StringBuilder result = new StringBuilder();
        for (int i = 0; i < s_positions.size(); ++i) {
            while (s_ptr < s_positions.get(i)) {
                result.append(s.charAt(s_ptr));
                ++s_ptr;
            }
            while (t_ptr < t_positions.get(i)) {
                result.append(t.charAt(t_ptr));
                ++t_ptr;
            }
            result.append(s.charAt(s_ptr));
            ++s_ptr;
            ++t_ptr;
        }
        while (s_ptr < s.length()) {
            result.append(s.charAt(s_ptr));
            ++s_ptr;
        }
        while (t_ptr < t.length()) {
            result.append(t.charAt(t_ptr));
            ++t_ptr;
        }
        return result.toString();
    }

    String Solve(String S) {
        int length_of_S = S.length();
        int[] last_occurence = new int[kAlphabetSize];
        Arrays.fill(last_occurence, -1);
        int[] next_occurence = new int[length_of_S];
        Arrays.fill(next_occurence, -1);
        for (int i = 0; i < length_of_S; ++i) {
            char c = S.charAt(i);
            if (last_occurence[c] != -1) {
                next_occurence[last_occurence[c]] = i;
            }
            last_occurence[c] = i;
        }
        // Case 1: odd number of symbols in palindrom.
        int[] v = new int[length_of_S];
        Arrays.fill(v, 0);
        int[] next = new int[length_of_S];
        int min_length_odd = 2 * length_of_S + 1;
        int min_center_position_odd = -1;
        for (int center = 0; center < length_of_S; ++center) {
            int cur_length;
            if (center + 1 == length_of_S) {
                cur_length = 2 * length_of_S - 1;
            } else {
                cur_length = 1 +
                        2 * (center + (length_of_S - center - 1 - v[center + 1]));
            }
            if (cur_length < min_length_odd) {
                min_length_odd = cur_length;
                min_center_position_odd = center;
            }

            Arrays.fill(next, 0);

            int next_center_pos = next_occurence[center];
            for (int i = center + 1; i < length_of_S; ++i) {
                while (next_center_pos != -1 && next_center_pos < i) {
                    next_center_pos = next_occurence[next_center_pos];
                }
                if (next_center_pos == -1) {
                    next[i] = v[i];
                } else {
                    if (next_center_pos + 1 < length_of_S) {
                        next[i] = Math.max(1 + v[next_center_pos + 1], v[i]);
                    } else {
                        next[i] = Math.max(1, v[i]);
                    }
                }
            }
            System.arraycopy(next, 0, v, 0, length_of_S);
        }

        // Case 2: even number of symbols in palindrom.
        Arrays.fill(v, 0);
        int last_zero_pos = last_occurence[S.charAt(0)];
        for (int i = last_zero_pos; i > 0; --i) {
            v[i] = 1;
        }

        int min_length_even = 2 * length_of_S + 1;
        int min_center_position_even = -1;
        for (int center = 0; center < length_of_S; ++center) {
            int cur_length;
            if (center + 1 == length_of_S) {
                cur_length = 2 * length_of_S;
            } else {
                cur_length = 2 *
                        (center + 1 + (length_of_S - center - 1 - v[center + 1]));
            }

            if (cur_length < min_length_even) {
                min_length_even = cur_length;
                min_center_position_even = center;
            }

            Arrays.fill(next, 0);


            int next_center_pos = -1;
            if (center + 1 < length_of_S) {
                next_center_pos = next_occurence[center + 1];
            }
            for (int i = center + 2; i < length_of_S; ++i) {
                while (next_center_pos != -1 && next_center_pos < i) {
                    next_center_pos = next_occurence[next_center_pos];
                }
                if (next_center_pos == -1) {
                    next[i] = v[i];
                } else {
                    if (next_center_pos + 1 < length_of_S) {
                        next[i] = Math.max(1 + v[next_center_pos + 1], v[i]);
                    } else {
                        next[i] = Math.max(1, v[i]);
                    }
                }
            }

            System.arraycopy(next, 0, v, 0, length_of_S);
        }
        if (min_length_odd < min_length_even) {
            String left = new StringBuilder(S.substring(0, min_center_position_odd)).reverse().toString();
            String right = S.substring(min_center_position_odd + 1);
            String right_palindrom = MergeStrings(left, right);
            String left_palindrom = new StringBuilder(right_palindrom).reverse().toString();
            String ans = left_palindrom + S.charAt(min_center_position_odd) + right_palindrom;
            return ans;
        } else {
            String left = new StringBuilder(S.substring(0, min_center_position_even + 1)).reverse().toString();
            String right = S.substring(min_center_position_even + 1);
            String right_palindrom = MergeStrings(left, right);
            String left_palindrom = new StringBuilder(right_palindrom).reverse().toString();
            String ans = left_palindrom + right_palindrom;
            return ans;
        }
    }

    void Output(String S, String palindrom) {
        out.println(palindrom.length() - S.length());
        out.println(palindrom);
    }

    class Pair<F, S> {
        public F first;
        public S second;

        public Pair(F first, S second) {
            this.first = first;
            this.second = second;
        }
    }

    public void solve() throws IOException {
        String S = Input();
        String palindrom = Solve(S);
        Output(S, palindrom);
    }

    public void run() {
        try {
            in = new FastScanner(System.in);
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            System.err.print(e);
            System.exit(1);
        }
    }

    public static void main(String[] args) {
        new sol_il_java().run();
    }

    static class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(InputStream inputStream) {
            br = new BufferedReader(new InputStreamReader(inputStream));
        }

        String next() {
            try {
                while (st == null || !st.hasMoreTokens())
                    st = new StringTokenizer(br.readLine());
            } catch (IOException e) {
                System.err.print(e);
                System.exit(1);
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        long nextLong() {
            return Long.parseLong(next());
        }
    }
}
