#include <algorithm>
#include <cassert>
#include <iostream>
#include <string>
#include <vector>
#include <cmath>
using namespace std;

#define mp make_pair

static const int kAlphabetSize = 300;

bool IsPalindrom(const string& s) {
  for (int i = 0; i < (int)s.size(); ++i) {
    if (s[i] != s[(int)s.size() - i - 1]) {
      return false;
    }
  }
  return true;
}

string Input() {
  string S;
  cin >> S;
  return S;
}

pair<vector<int>, vector<int> > rest_ans(
    const string& s, const string& t,
    int l, int r,
    const vector<int>& lh, const vector<int>& rh,
    int position, int& npos) {
  pair<vector<int>, vector<int> > result;
  if (l >= r) {
    return result;
  }

  if (l == r - 1) {
    if (position > 0 && s[r - 1] == t[position - 1]) {
      result.first.push_back(r - 1);
      result.second.push_back(position - 1);
      npos = position - 1;
    } else {
      while (position > 0) {
        if (rh[position] == rh[position - 1]) {
          --position;
        } else {
          if (lh[position] == rh[position]) {
            npos = position;
            return result;
          } else {
            if (s[r - 1] == t[position - 1]) {
              result.first.push_back(r - 1);
              result.second.push_back(position - 1);
              npos = position - 1;
              return result;
            } else {
              assert(false);
            }
          }
        }
      }

      if (position == 0) {
        npos = 0;
      }
    }
    return result;
  }

  int split_num = (l + r) >> 1;
  vector<int> prev(t.size() + 1, 0);
  vector<int> cur(t.size() + 1, 0);

  cur = lh;
  for (int i = l + 1; i <= split_num; ++i) {
    prev = cur;
    cur.assign(t.size() + 1, 0);
    for (int j = 1; j <= (int)t.size(); ++j) {
      if (prev[j] > cur[j - 1]) {
        cur[j] = prev[j];
      } else {
        cur[j] = cur[j - 1];
      }

      if (s[i - 1] == t[j - 1] && cur[j] < prev[j - 1] + 1) {
        cur[j] = prev[j - 1] + 1;
      }
    }
  }

  pair<vector<int>, vector<int> > rres =
      rest_ans(s, t, split_num, r, cur, rh, position, npos);
  pair<vector<int>, vector<int> > lres =
      rest_ans(s, t, l, split_num, lh, cur, npos, npos);

  result.first.reserve(lres.first.size() + rres.first.size());
  result.first.insert(result.first.end(),
                      lres.first.begin(),
                      lres.first.end());
  result.first.insert(result.first.end(),
                      rres.first.begin(),
                      rres.first.end());

  result.second.reserve(lres.second.size() + rres.second.size());
  result.second.insert(result.second.end(),
                       lres.second.begin(),
                       lres.second.end());
  result.second.insert(result.second.end(),
                       rres.second.begin(),
                       rres.second.end());

  return result;
}

void LCS(const string& s, const string& t,
         vector<int>* s_positions, vector<int>* t_positions) {
  vector<int> prev(t.size() + 1, 0);
  vector<int> cur(t.size() + 1, 0);

  for (int i = 1; i <= (int)s.size(); ++i) {
    prev = cur;
    cur.assign(t.size() + 1, 0);
    for (int j = 1; j <= (int)t.size(); ++j) {
      if (prev[j] > cur[j - 1]) {
        cur[j] = prev[j];
      } else {
        cur[j] = cur[j - 1];
      }

      if (s[i - 1] == t[j - 1] && cur[j] < prev[j - 1] + 1) {
        cur[j] = prev[j - 1] + 1;
      }
    }
  }

  int max_position = 0;
  for (int i = 0; i <= t.size(); ++i) {
    if (cur[i] > cur[max_position]) {
      max_position = i;
    }
  }

  int npos = 0;
  pair<vector<int>, vector<int> > res = 
      rest_ans(s, t,
               0, (int)s.size(),
               vector<int>(t.size() + 1, 0), cur,
               max_position, npos);

  /*cout << s << " " << t << endl;
  cout << "s_positions:" << endl;
  for (int i = 0; i < (int)res.first.size(); ++i) {
    cout << res.first[i] << " ";
  }
  cout << endl;
  cout << "t_positions:" << endl;
  for (int i = 0; i < (int)res.second.size(); ++i) {
    cout << res.second[i] << " ";
  }
  cout << endl;*/

  *s_positions = res.first;
  *t_positions = res.second;
}

string MergeStrings(const string& s, const string& t) {
  vector<int> s_positions;
  vector<int> t_positions;
  LCS(s, t, &s_positions, &t_positions);
  int s_ptr = 0;
  int t_ptr = 0;
  string result;
  for (int i = 0; i < (int)s_positions.size(); ++i) {
    while (s_ptr < s_positions[i]) {
      result += s[s_ptr];
      ++s_ptr;
    }
    while (t_ptr < t_positions[i]) {
      result += t[t_ptr];
      ++t_ptr;
    }
    result += s[s_ptr];
    ++s_ptr;
    ++t_ptr;
  }
  while (s_ptr < s.size()) {
    result += s[s_ptr];
    ++s_ptr;
  }
  while (t_ptr < t.size()) {
    result += t[t_ptr];
    ++t_ptr;
  }
  return result;
}

string Solve(const string& S) {
  const int length_of_S = S.size();
  vector<int> last_occurence(kAlphabetSize, -1);
  vector<int> next_occurence(length_of_S, -1);
  for (int i = 0; i < (int)length_of_S; ++i) {
    if (last_occurence[S[i]] != -1) {
      next_occurence[last_occurence[S[i]]] = i;
    }
    last_occurence[S[i]] = i;
  }
  // Case 1: odd number of symbols in palindrom.
  vector<int> v(length_of_S, 0);
  vector<int> next(length_of_S);
  int min_length_odd = 2 * length_of_S + 1;
  int min_center_position_odd = -1;
  for (int center = 0; center < length_of_S; ++center) {
    int cur_length;
    if (center + 1 == length_of_S) {
      cur_length = 2 * length_of_S - 1;
    } else {
      cur_length = 1 +
          2 * (center + (length_of_S - center - 1 - v[center + 1]));
    }
    if (cur_length < min_length_odd) {
      min_length_odd = cur_length;
      min_center_position_odd = center;
    }

    next.assign(length_of_S, 0);

    int next_center_pos = next_occurence[center];
    for (int i = center + 1; i < length_of_S; ++i) {
      while (next_center_pos != -1 && next_center_pos < i) {
        next_center_pos = next_occurence[next_center_pos];
      }
      if (next_center_pos == -1) {
        next[i] = v[i];
      } else {
        if (next_center_pos + 1 < length_of_S) {
          next[i] = max(1 + v[next_center_pos + 1], v[i]);
        } else {
          next[i] = max(1, v[i]);
        }
      }
    }

    v.swap(next);
  }

  // Case 2: even number of symbols in palindrom.
  v.assign(length_of_S, 0);
  int last_zero_pos = last_occurence[S[0]];
  for (int i = last_zero_pos; i > 0; --i) {
    v[i] = 1;
  }

  int min_length_even = 2 * length_of_S + 1;
  int min_center_position_even = -1;
  for (int center = 0; center < length_of_S; ++center) {
    int cur_length;
    if (center + 1 == length_of_S) {
      cur_length = 2 * length_of_S;
    } else {
      cur_length = 2 *
          (center + 1 + (length_of_S - center - 1 - v[center + 1]));
    }

    if (cur_length < min_length_even) {
      min_length_even = cur_length;
      min_center_position_even = center;
    }

    next.assign(length_of_S, 0);


    int next_center_pos;
    if (center + 1 < length_of_S) {
      next_center_pos = next_occurence[center + 1];
    }
    for (int i = center + 2; i < length_of_S; ++i) {
      while (next_center_pos != -1 && next_center_pos < i) {
        next_center_pos = next_occurence[next_center_pos];
      }
      if (next_center_pos == -1) {
        next[i] = v[i];
      } else {
        if (next_center_pos + 1 < length_of_S) {
          next[i] = max(1 + v[next_center_pos + 1], v[i]);
        } else {
          next[i] = max(1, v[i]);
        }
      }
    }

    v.swap(next);
  } 
  if (min_length_odd < min_length_even) {
    string left = S.substr(0, min_center_position_odd);
    reverse(left.begin(), left.end());
    string right = S.substr(min_center_position_odd + 1);
    string right_palindrom = MergeStrings(left, right);
    string left_palindrom = right_palindrom;
    reverse(left_palindrom.begin(), left_palindrom.end());
    string ans = left_palindrom + S[min_center_position_odd] + right_palindrom;
    assert(ans.size() == min_length_odd);
    return ans;
  } else {
    string left = S.substr(0, min_center_position_even + 1);
    reverse(left.begin(), left.end());
    string right = S.substr(min_center_position_even + 1);
    string right_palindrom = MergeStrings(left, right);
    string left_palindrom = right_palindrom;
    reverse(left_palindrom.begin(), left_palindrom.end());
    string ans = left_palindrom + right_palindrom;
    assert(ans.size() == min_length_even);
    return ans;
  }
}

void Output(const string& S, const string& palindrom) {
  cout << (int)palindrom.size() - (int)S.size() << endl;
  cout << palindrom << endl;
}

int main() {
  const string S = Input();
  const string palindrom = Solve(S);
  Output(S, palindrom);
}
