import math

def gcd(a, b):
    return a if b == 0 else gcd(b, a % b)


def find_prime_divisors_leman(n):    
    divisors = []
    sqrt3_n_up = math.ceil(n ** (1 / 3)) + 1
    
    # finding divisors <= n ^ (1 / 3)
    m = 2    
    while m * m <= n and m < sqrt3_n_up:
        while n % m == 0:
            divisors.append(m)
            n //= m
        m += 1
    if m * m > n:
        if n != 1:
            divisors.append(n)
        return divisors
        
    # either n is prime or n = p * q,  n ^ (1 / 3) < p <= q < n ^ (2 / 3)
    for k in range(1, sqrt3_n_up):
        max_d = math.ceil((n ** (1 / 6)) / (4 * k ** (1 / 2))) + 2
        s = 4 * k * n
        t = math.floor(s ** (1 / 2))
        if t * t < s:
            t += 1
        assert t ** 2 >= s        
        for d in range(max_d):
            a = t + d
            diff = a ** 2 - s            
            b = round(diff ** (1 / 2))
            if b * b == diff:
                # a ^ 2 = b ^ 2 mod n
                d1 = gcd(a + b, n)
                d2 = gcd(a - b, n)
                if 1 < d1 < n or 1 < d2 < n:                    
                    p = d1 if 1 < d1 < n else d2
                    divisors.append(p)
                    divisors.append(n // p)
                    return divisors
            
    # n is prime
    divisors.append(n)
    return divisors


n = int(input())
prime_divisors = find_prime_divisors_leman(n - 1)
print(len(prime_divisors))
print(' '.join(map(lambda x: str(x - 1), prime_divisors)))
