#include <iostream>
#include <vector>

using namespace std;

vector<unsigned long long> find_divisors_sqrt(unsigned long long n) {
  vector<unsigned long long> divisors;

  unsigned long long m = 2;  
  while (m * m <= n) {
    while (n % m == 0) {
      divisors.push_back(m);
      n /= m;
    }
    ++m;
  }
  if (n > 1) {
    divisors.push_back(n);
  }
  return divisors;
}

int main() {
  unsigned long long n;
  cin >> n;
  vector<unsigned long long> divisors = find_divisors_sqrt(n - 1);
  cout << divisors.size() << endl;
  for (int i = 0; i < divisors.size(); ++i) {
    cout << (i == 0 ? "" : " ") << divisors[i] - 1;
  }
  cout << endl;
  return 0;
}