import java.io.*;
import java.math.*;
import java.util.*;

public class sol_ra_pollard {
    Random rnd = new Random(239);
    ArrayList<BigInteger> factorize(BigInteger n) {
        //System.err.println(n);
        ArrayList<BigInteger> res = new ArrayList<>();
        if (n.equals(BigInteger.ONE)) {
            return res;
        }
        if (n.compareTo(BigInteger.valueOf(10000)) < 0) {
            int N = n.intValue();
            for (int i = 2; i * i <= N; i++) {
                while (N % i == 0) {
                    N /= i;
                    res.add(BigInteger.valueOf(i));
                }
            }
            if (N != 1) {
                res.add(BigInteger.valueOf(N));
            }
            return res;
        }
        int cnt1 = 0;
        while (cnt1 < 5) {
            cnt1++;
            BigInteger x = BigInteger.valueOf(rnd.nextInt() % 10 + 1);
            x = x.mod(n);
            BigInteger y = x;
            BigInteger d = BigInteger.ONE;
            BigInteger c = BigInteger.valueOf(rnd.nextInt() % 21 - 10);
            int cnt2 = 0;
            int sq = Math.max(10, (int) (Math.pow(n.doubleValue(), 0.25) * 2));
            while (d.equals(BigInteger.ONE) && cnt2 < sq) {
                cnt2++;
                x = x.multiply(x).add(c).mod(n);
                y = y.multiply(y).add(c).mod(n);
                y = y.multiply(y).add(c).mod(n);
                d = (x.subtract(y)).gcd(n);
            }
            if (!(d.equals(n) || d.equals(BigInteger.ONE))) {
                res = factorize(d);
                res.addAll(factorize(n.divide(d)));
                return res;
            }
        }
        res.add(n);
        return res;
    }
    void solve() throws IOException{
        Scanner sc = new Scanner(System.in);
        PrintWriter pw = new PrintWriter(System.out);
        BigInteger n = sc.nextBigInteger();
        n = n.subtract(BigInteger.ONE);
        ArrayList<BigInteger> ans = factorize(n);
        pw.println(ans.size());
        for (BigInteger x : ans) {
            pw.print(x.subtract(BigInteger.ONE) + " ");
        }
        pw.println();
        sc.close();
        pw.close();
    }
    void run() {
        try {
            solve();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
    public static void main(String[] args) {
        (new sol_ra_pollard()).run();
    }
}
