#include "testlib.h"
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cstring>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <list>
#include <deque>
#include <queue>
#include <sstream>
#include <iostream>
#include <algorithm>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const double pi = acos(-1.0);


int main(int argc, char ** argv) {
	registerGen(argc, argv, 1);

	if (argc != 8) {
		cerr << "Usage: n1, n2, d, minC, maxC, distinct, seed" << endl;

		return 1;
	}	

	int n1 = atoi(argv[1]);
	int n2 = atoi(argv[2]);
	int d = atoi(argv[3]);
	int cl = atoi(argv[4]);
	int cr = atoi(argv[5]);
	int dist = atoi(argv[6]);

	set <int> dst;
	while ((int) dst.size() < dist)
		dst.insert(rnd.next(cl, cr));
	
	vector <int> touse;
	while (!dst.empty()) {
		touse.pb(*dst.begin());
		dst.erase(dst.begin());
	}

	printf("%d %d\n", n1 + n2, d);

	vector <int> pts;
	for (int i = 0; i < n1; i++)
		pts.pb(touse[rnd.next(0, dist - 1)]);
	for (int i = 0; i < n2; i++)
		pts.pb(rnd.next(cl, cr));

	shuffle(pts.begin(), pts.end());
	for (int i = 0; i < (int) pts.size(); i++)
		printf("%d%c", (int) pts[i], " \n"[i == (int) pts.size() - 1]);

    return 0;
}