#include "testlib.h"
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cstring>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <list>
#include <deque>
#include <queue>
#include <sstream>
#include <iostream>
#include <algorithm>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const double pi = acos(-1.0);

const int groups = 2;
const int minN[groups] = {1, 1};
const int maxN[groups] = {1000, 100 * 1000};
const int minABC[groups] = {1, 1};
const int maxABC[groups] = {1000, 1000 * 1000};

int main(int argc, char ** argv) {
	registerValidation(argc, argv);

	int group = atoi(validator.group().data());

	ensuref(0 <= group && group <= 2, "Wrong group number");
	group--;

	if (group == -1)
		group = 0;

	int n = inf.readInt(minN[group], maxN[group], "n");
	inf.readSpace();
	int a = inf.readInt(minABC[group], maxABC[group], "a");
	inf.readSpace();
	int b = inf.readInt(minABC[group], a, "b");
	inf.readSpace();
	int c = inf.readInt(minABC[group], b, "c");
	inf.readEoln();
	
	vector <pair <int, int> > segs;
	for (int i = 0; i < n; i++) {
		int lb = inf.readInt(1, a);
		inf.readSpace();
		int rb = inf.readInt(lb, a);
		inf.readEoln();

		segs.pb(mp(lb, rb));
	}
	inf.readEof();

	sort(segs.begin(), segs.end());
	for (int i = 0; i < n - 1; i++)
		ensuref(segs[i].sc < segs[i + 1].fs, "trips must not overlap");

    return 0;
}